'use strict';

var Dt = require('crypto');
var ze = require('fs');
var path = require('path');
var promises = require('fs/promises');
var Ei = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Dt__default = /*#__PURE__*/_interopDefault(Dt);
var ze__default = /*#__PURE__*/_interopDefault(ze);
var Ei__default = /*#__PURE__*/_interopDefault(Ei);

function Ar(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function X(){let e=Ar();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function vr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Cr(){return vr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function N(e=Cr()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function Er(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Ze(e){if(e===!1)return ee;if(typeof e=="number")return e;if(typeof e=="string"){let t=$t[e.toLocaleLowerCase().trim()];if(t!=null)return t}return W}function z(e=Er()){let t=Ze(e);return n=>n>=t}function we(e={}){let{level:t=void 0,filter:n=void 0}=e,r=N(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${a}`,...i.messages);break;case B:console.warn(`W|**  ${a}`,...i.messages);break;case $:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var W=-1,J=0,O=1,B=2,$=3,Te=4,ee=9007199254740991,$t={"*":W,a:W,all:W,d:J,dbg:J,debug:J,i:O,inf:O,info:O,w:B,warn:B,warning:B,e:$,err:$,error:$,fatal:Te,off:ee,"-":ee};function Ot(e=""){let t=[we()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let p=Ze(c??W);function l(g,m){return p<=g?m:()=>{}}let f=l(J,(...g)=>{d({name:u,messages:g,level:J});});f.label=u,f.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return f.debug=l(J,(...g)=>{d({name:u,messages:g,level:J});}),f.info=l(O,(...g)=>{d({name:u,messages:g,level:O});}),f.warn=l(B,(...g)=>{d({name:u,messages:g,level:B});}),f.error=l($,(...g)=>{d({name:u,messages:g,level:$});}),f.fatal=l(Te,(...g)=>{throw d({name:u,messages:g,level:Te}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(Te,(g,...m)=>{(g==null||typeof g=="number"&&isNaN(g)||!g)&&f.fatal(...m);}),f}function s(u="",c){let p=o(u,c);return i&&p.debug(`+++ init of logger "${u}" on level "${p.level}".`),p}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=N(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=W,s.setLogLevel=function(u=W){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var V;function Ke(e){let t=Ot();return e?e(t):t.setHandlers([we()]),t}function Ye(e){if(V==null)try{let t=X();t!=null?t?.logger==null?(V=Ke(e),t.logger=V):V=t.logger:V=Ke(e);}catch{V=Ke(e);}return V}function _t(){if(V!=null)return V;try{let e=X();if(e?.logger!=null)return e.logger}catch{}}function R(e,t){return Ye()(e,t)}function Ur(...e){throw _t()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Fr(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&Ur(...t);}function Nt(e,...t){Fr(e,...t);}var jt=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function Wi(e,t=void 0){return JSON.stringify(e,jt,t)}function Dr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);i=jt(o,i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function k(e,t,n,r){return JSON.stringify(e,Dr(t,r),n)}var qi=k;function Sr(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Pr(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var Le;function Vt(e){if(Le==null&&(Le=Sr,typeof TextEncoder<"u")){let t=new TextEncoder;Le=n=>t.encode(n);}return Le(e.normalize("NFC"))}var Ae;function Ht(e){if(Ae==null&&(Ae=Pr,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Ae=n=>t.decode(n);}return Ae(e).normalize("NFC")}function E(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Vt(e):e.length?new Uint8Array(e):e}function Ki(...e){let t=0,n=e.flat(1).map(i=>{let a=E(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function Gt(e){if(typeof Buffer<"u")return Buffer.from(E(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...E(e)])n+=t[r>>4]+t[r&15];return n}function zt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function fe(e,t=!1){let n=E(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function Yi(e){let t=E(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function ve(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function Qi(e){return Ht(ve(e))}function Wt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=E(e),r=E(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Qe(e){return Vt(k(e))}function Xe(e){return JSON.parse(Ht(e))}function qt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let p=c.charCodeAt(0);return ` ${r[(240&p)>>4]}${r[15&p]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}var te;function Zt(){return te===void 0&&(te=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,te&&te.decode(new Uint8Array).length===1&&(te=null)),te}var Yt="Unexpected end of array",Qt="Integer out of Range",et=class{constructor(t){this.arr=t,this.pos=0;}};function Fe(e){return new et(e)}function tt(e,t){let n=ge(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function ne(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function De(e){return tt(e,ne(e))}function de(e){return e.arr[e.pos++]}function Xt(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function en(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function nt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function Ir(e){let t=ne(e);if(t===0)return "";{let n=String.fromCodePoint(de(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(de(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function Ue(e){let t=Zt();return t?t.decode(De(e)):Ir(e)}function rt(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function ot(e){return rt(e,4).getFloat32(0,!1)}function Mr(e){return rt(e,8).getFloat64(0,!1)}function Br(e){return rt(e,8).getBigInt64(0,!1)}var $r=[e=>{},e=>null,nt,ot,Mr,Br,e=>!1,e=>!0,Ue,e=>{let t=ne(e),n={};for(let r=0;r<t;r++){let o=Ue(e);n[o]=re(e);}return n},e=>{let t=ne(e),n=[];for(let r=0;r<t;r++)n.push(re(e));return n},De];function re(e){return $r[127-de(e)](e)}function ge(e,t,n){return new Uint8Array(e,t,n)}var it=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function Re(){return new it}function st(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function ke(e){let t=new Uint8Array(st(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(ge(e.cbuf.buffer,0,e.cpos),n),t}function Or(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(ge(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function F(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var rn=F;function on(e,t){F(e,t&255),F(e,t>>>8&255);}function sn(e,t){for(let n=0;n<4;n++)F(e,t&255),t>>>=8;}function Z(e,t){for(;t>127;)F(e,128|127&t),t=Math.floor(t/128);F(e,127&t);}function _r(e){return e!==0?e<0:1/e<0}function at(e,t){let n=_r(t);for(n&&(t=-t),F(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)F(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function Ie(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function Me(e,t){Z(e,t.byteLength),Ie(e,t);}function jr(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;Z(e,r);for(let o=0;o<r;o++)F(e,n.codePointAt(o));}function Pe(e,t){return jr(e,t)}function ut(e,t){Or(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function ct(e,t){return ut(e,4).setFloat32(0,t,!1)}function Vr(e,t){return ut(e,8).setFloat64(0,t,!1)}function Hr(e,t){return ut(e,8).setBigInt64(0,t,!1)}var Se;function Gr(e){return Se==null&&(Se=new DataView(new ArrayBuffer(4))),Se.setFloat32(0,e),Se.getFloat32(0)===e}function ie(e,t){switch(typeof t){case"string":F(e,119),Pe(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(F(e,125),at(e,t)):Gr(t)?(F(e,124),ct(e,t)):(F(e,123),Vr(e,t));break;case"bigint":F(e,122),Hr(e,t);break;case"object":if(t===null)F(e,126);else if(Array.isArray(t)){F(e,117),Z(e,t.length);for(let n=0;n<t.length;n++)ie(e,t[n]);}else if(t instanceof Uint8Array)F(e,116),Me(e,t);else {F(e,118);let n=Object.keys(t);Z(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];Pe(e,o),ie(e,t[o]);}}break;case"boolean":F(e,t?120:121);break;default:F(e,127);}}var an=class{async encode(t){let n=Re();return ie(n,t),ke(n)}async decode(t){return re(Fe(E(t)))}};function ms(e){let t=Re();return ie(t,e),ke(t)}function ys(e){return re(Fe(E(e)))}function hs(e){let t=Re();return e!=null&&Ie(t,E(e)),{writeBytes:(n,r)=>{let o=E(n);Nt(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),Ie(t,o);},writeBytesVar:n=>Me(t,E(n)),writeUintVar:n=>Z(t,n),writeUint8:n=>rn(t,n),writeUint16:n=>on(t,n),writeUint32:n=>sn(t,n),writeIntVar:n=>at(t,n),writeFloat:n=>ct(t,n),writeStringVar:n=>Pe(t,n),write:n=>ie(t,n),getUint8Array:()=>ke(t),getLength:()=>st(t)}}function xs(e){let t=Fe(E(e));return {readBytes:n=>tt(t,n),readBytesVar:()=>De(t),readUintVar:()=>ne(t),readUint8:()=>de(t),readUint16:()=>Xt(t),readUint32:()=>en(t),readIntVar:()=>nt(t),readFloat:()=>ot(t),readStringVar:()=>Ue(t),read:()=>re(t),getOffset:()=>t.pos||0}}function bs(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function zr(e){return await e.arrayBuffer()}async function ws(e){let t=await zr(e);if(t!=null)return E(t)}function se(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var cn="SHA-256",lt="AES-GCM",un="PBKDF2",Wr=1e5;async function As(e,t=cn){return E(await crypto.subtle.digest(t,E(e)))}async function vs(e,t={}){let n=E(e),r=await crypto.subtle.importKey("raw",n,un,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:un,salt:t.salt?E(t.salt):new Uint8Array(0),iterations:t.iterations??Wr,hash:cn},r,{name:lt,length:256},!0,["encrypt","decrypt"])}function ln(){return new Uint8Array([1,1])}async function fn(e,t){let n=ln(),r=se(12),o=await crypto.subtle.encrypt({name:lt,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function pn(e,t){let n=e.subarray(0,2);if(!Wt(n,ln()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:lt,iv:r},t,o);return new Uint8Array(i)}function qr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function S(){return typeof crypto<"u"?qr():Math.random()}function Es(e=.25){return S()<e}function Us(e=100,t=0){return t+Math.floor(S()*(e-t))}function Fs(e=100,t=0){return t+S()*(e-t)}function Ds(e,t,n){return Math.max(e,Math.min(n,t))}function Jr(e){return e.reduce((t,n)=>t+n,0)}function Ss(e){return Jr(e)/e.length}function Ps(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function Rs(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var ft=6;function ks(e=0,t=1,n){ft=((n??ft)*9301+49297)%233280;let r=ft/233280;return t+r*(e-t)}function Zr(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Ms(e,t=!0){return `${e} ${t?"asc":"desc"}`}function pt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Bs(e,...t){if(t.length>0){let n=t.map(Zr),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=pt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function dt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Kr(e,t){return dt(e.filter(n=>!t.includes(n)))}function Yr(...e){return dt(e.reduce((t=[],n)=>t.concat(n),[]))}function ae(...e){return e.flat(1/0)}function Qr(e,t){return dt(e).filter(n=>t.includes(n))}function Ns(e,t){return Kr(Yr(e,t),Qr(e,t))}function dn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function js(e,t){return e.includes(t)||e.push(t),e}function gt(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Vs(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function Hs(e){return e.splice(0,e.length),e}function Xr(e,t=pt){return Array.from(e).sort(t)}function Gs(e){return Xr(e,(t,n)=>t-n)}function eo(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function gn(e){return e.sort(()=>S()>.5?1:-1),e}function zs(e){return gn(Array.from(e))}function Ws(e){for(;e.length>1;){let t=Array.from(e);if(gn(t),!eo(e,t))return t}return e}function qs(e){return e[Math.floor(S()*e.length)]}function Js(...e){return ae(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Zs(...e){return ae(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function Ks(...e){return ae(e).reduce((t,n)=>t+n,0)}function Ys(...e){let t=ae(e);return t.reduce((n,r)=>n+r,0)/t.length}function Qs(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function Xs(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var to={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function no(e){let t=to[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let p=t.charAt(c),l=p.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${p} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,p=-1){let l=E(c);if(l.byteLength===0)return "";let f=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,b=new Uint8Array(m);for(;d!==g;){let v=l[d],U=0;for(let h=m-1;(v!==0||U<f)&&h!==-1;h--,U++)v+=256*b[h]>>>0,b[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");f=U,d++;}let y=m-f;for(;y!==m&&b[y]===0;)y++;let T="";for(;y<m;++y)T+=t.charAt(b[y]);return p>0?T.padStart(p,o):T}function u(c,p=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let T=d-1;(b!==0||y<f)&&T!==-1;T--,y++)b+=r*g[T]>>>0,g[T]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=y,l++;}let m=d-f;for(;m!==d&&g[m]===0;)m++;return p>0?new Uint8Array([...new Uint8Array(p-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Be;function q(e){Be==null&&(Be=new Map);function t(){let o=Be.get(e);return o==null&&(o=no(e),Be.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function mt(e,t=-1){return q(32).encode(e,t)}function mn(e,t=-1){return q(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function na(e,t=-1){return q(16).encode(e,t)}function ra(e,t=-1){return q(16).decode(e,t)}function oa(e,t=-1){return q(58).encode(e,t)}function ia(e,t=-1){return q(58).decode(e,t)}function yt(e,t=-1){return q(62).encode(e,t)}function yn(e,t=-1){return q(62).decode(e,t)}function sa(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var hn=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function ro(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function ua(e){return e.replace(/\w\S*/g,ro)}function ca(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var xn=["1","true","yes","y","on"];function pa(e,t=!1){return e==null||typeof e!="string"?t:xn.includes(String(e).trim().toLowerCase())}function da(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function ga(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function ue(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:xn.includes(String(e).trim().toLowerCase())}function oo(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function io(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function ht(e,t=""){return e==null?t:String(e)??t}var ma=io,ya=oo,ha=ht,xa=ue;function so(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${qt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function $e(e,t={}){return so(e,t).join(" ")}function ba(e){try{return decodeURIComponent(escape(e))}catch{}return e}function La(e){if(e.startsWith("data:"))return ve(e.split(",",2)[1])}function Aa(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function va(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([ve(n)],{type:t})}}async function Ca(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${fe(t)}`}function Ea(e,t="application/octet-stream"){return `data:${t},${fe(e)}`}var bn=864e5;function bt(e){return Math.floor(e/1e4)}function wn(e){return Math.floor(e/100%100)}function ao(e){return Math.floor(e%100)}function Fa(e){return [bt(e),wn(e),ao(e)]}function Tn(e,t=!1){return t?new Date(`${co(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Ln(){return _e(new Date)}function Da(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return An(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return wt(n,r,o)}else if(e instanceof Date)return _e(e,t)}function Sa(e){return Tn(e,!0)}function _e(e,t=!1){return t?An(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Pa(e){return _e(e,!0)}function xt(e,t=!0){return Tn(e,t).getTime()}function uo(e,t=!0){return _e(new Date(e),t)}function co(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function wt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function An(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function Ra(e,t=0){let n=bt(e),r=wn(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),wt(n,r,1)}function ka(e,t=0){let n=bt(e);return wt(n+t,1,1)}function Oe(e,t){return uo(xt(e)+t*864e5)}function Ia(e,t){return Math.round((xt(t)-xt(e))/864e5)}function Ma(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)n.push(e),e=Oe(e,1);return n}function*Ba(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)yield e,e=Oe(e,1);return n}function vn(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Oa(e){return new Promise(t=>setTimeout(t,e))}async function _a(){return new Promise(e=>setTimeout(e,0))}async function Na(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function ja(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function Cn(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function Va(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function I(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function H(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function za(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);I(i)&&await i,r=r.dayOffset(1);}}function Wa(){return new A}function qa(e){return new A(e)}function Ja(e){return A.fromDate(new Date(e)).days}function lo(e,t=2){return +(+e).toFixed(t)}function Ka(e,t=2){return +(+e/10**t).toFixed(t)}function Ya(e,t=2){return Math.round(+e*10**t)}function Qa(e,t=2){return t*(lo(e,t)%1)}function tu(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function nu(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function En(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function ru(e){return e!=null&&e.length>0?e[0]:void 0}function ou(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function iu(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function ce(e){return Object(e)!==e?e:JSON.parse(k(e))}function su(e){return Object(e)!==e?e:JSON.parse(k(e))}function au(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function uu(e){let t=new Map;return async(...n)=>{let r=k(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function cu(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}function j(e){return e!=null&&typeof e=="object"}function Tt(e){return Object(e)!==e}function G(e){return Array.isArray(e)}function Ne(e){return j(e)&&!G(e)}function pu(e){return e?.constructor===Object}function Un(e){return typeof e=="string"}function Fn(e){return typeof e=="number"&&!isNaN(e)}function du(e){return Fn(e)&&Number.isInteger(e)}function gu(e){return Fn(e)&&Number.isSafeInteger(e)}function Dn(e){return typeof e=="boolean"}function mu(e){return e==null}function yu(e){return e==null}function hu(e){return j(e)&&e.constructor.name==="Uint8Array"}function Sn(e){return e!=null}function fo(e){return e==null||e===""||j(e)&&En(e)<=0}function xu(e){return !fo(e)}function bu(e){return e!=null&&e!==!1&&e!==!0}function wu(e){return e!=null&&e!==!1&&e!==0&&e!==""}function po(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Tt(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!po(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function go(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Tt(e)||t.add(e),Ne(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}go(e[n],t);}}else if(G(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function je(e,...t){for(let n of t)j(e)||(e={}),!(n==null||!j(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):j(o)&&j(i)?e[r]=je(Object.assign({},o),i):e[r]=i;});return e}function mo(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let p=t[s],l=typeof u=="object"&&typeof p=="object";if(u&&p&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let f=mo(u,p,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...f.map(d=>(d.path.unshift(c),d))];}else u!==p&&!(l&&(isNaN(u)?`${u}`==`${p}`:+u==+p))&&o.push({path:[c],type:"upd",value:p});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}var Pn=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),Cu=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function Uu(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Fu(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Du(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Su(e,t){return e.map(n=>n[t])}function ku(e,t){return j(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return G(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function Iu(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function Mu(e){return Object.keys(e).length<=0}var Rn=/[\u0000-\u001F\u0080-\u009F]/g,yo=/^\.+/,ho=/\.+$/;function kn(){return /[<>:"/\\|?*\u0000-\u001F]/g}function xo(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function In(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(kn().test(t)&&Rn.test(t))throw new Error("Replacement string cannot contain reserved filename characters");return e=e.replace(kn(),t).replace(Rn,t).replace(yo,t).replace(ho,""),e=xo().test(e)?e+t:e,e.slice(0,100)}var bo=/[\\\-\[\]\/{}()*+?.^$|]/g;function Mn(e){return e?e instanceof RegExp?e.source:e.replace(bo,"\\$&"):""}var ye=e=>Math.abs(e)%1===.5,Bn=e=>e%2===0,_u=e=>Math.ceil(e),Nu=e=>Math.floor(e),ju=e=>Math.round(e),Vu=e=>{let t=Math.round(e);return ye(e)&&Bn(t)?t-1:t},Hu=e=>ye(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Gu=e=>ye(e)?Math.floor(e):Math.round(e),zu=e=>{let t=Math.round(e);return ye(e)?Bn(t)?t:t-1:t},Wu=e=>ye(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function $n(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-S()}function On(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+S()}function Zu(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return On(n);if(e<=0)return $n(n);n=wo([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?$n(n):On(n);let c=a+u/2,p=u*.01*(S()-.5);return c+p}function wo(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function Qu(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-S()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+S()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,p=s+c/2,l=c*.01*(S()-.5);return p+l}function a(s,u,c){let p=c.length,l=s<u;if(p<=0||s>=p-1)return o(c);if(s<=0)return r(c);c=n([...c]);let f=l?-1:0,d=t(c[s+f])||0,m=(t(c[s+f+1])||0)-d;if(m===0)return l?r(c):o(c);let b=d+m/2,y=m*.01*(S()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var To=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function tc(e){return e.split(To).map((t,n)=>{let r=Pn(t);return n%2?`<a target="_blank" href="${r}">${Lo(r)}</a>`:r}).join("")}function Lo(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function _n(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function nc(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}var Ao=/\\\s|\s+|#[^\n]*\n?/gm,vo=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,Nn=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Co(e){return typeof e=="string"?e:e.source||""}function oc(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var jn=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(Ao,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(vo,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Co(o),Nn.lastIndex=0;let a=Nn.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Eo=",";function ac(e,t={}){let{separator:n=Eo}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Dn(i))return i?1:0;let a=String(i);return (Ne(i)||G(i))&&(a=k(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function Uo(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Mn(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function uc(e,t={}){let n=Uo(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}async function Fo(e){typeof e=="function"?await H(e()):I(e)?await e:typeof e.dispose=="function"?await H(e.dispose()):I(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await H(e.cleanup()):I(e.cleanup)&&await e.cleanup;}function he(e){let t=e;t!=null&&(Un(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??R("zeed:dispose"),o=[],i=async u=>{u!=null&&o.includes(u)&&(gt(o,c=>c!==u),await Fo(u));},a=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},s=u=>{if(u!=null)return o.unshift(u),()=>i(u)};return Object.assign(a,{track:s,add:s,untrack:i,dispose:a,exec:a,getSize(){return o.length},isDisposed(){return o.length<=0}})}var gc=he;function mc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(gt(n,s=>s!==a),typeof a=="function"){let s=a();if(I(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(I(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function yc(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function hc(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function xc(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function Tc(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function Lc(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();I(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();I(o)&&await o;}return r}}var M=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=R("zeed:emitter","error");this.dispose=he();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return H(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await H(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Dc(){let e=X().emitter;return e||(e=new M,X().emitter=e),e}function Sc(e,t){let n=Math.round(S()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,p)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;p(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}var K=()=>Date.now();function Lt(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Rc(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var Vn=()=>typeof performance<"u"?performance.now():Date.now();function kc(){let e=Vn();return function(){let t=Vn()-e;return Lt(t)}}var Ve=16;function vt(){return se(Ve)}function Do(e=vt()){return yt(e,22)}function So(e){return yt(e,22)}function Po(e){return yn(e,Ve)}function Ro(e=vt()){return mt(e,26)}function ko(e){return mt(e,26)}function Io(e){return mn(e,Ve)}var Mo="10000000-1000-4000-8000-100000000000",Bo=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():Mo.replace(/[018]/g,e=>(e^se(1)[0]&15>>e/4).toString(16))};function $o(e){let t=Gt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function Oo(e){return zt(e.replaceAll("-",""))}var Hn=16e11;function _o(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Gn(){let e=K()-Hn;return new Uint8Array([..._o(e),...se(10)])}function _c(){return jo(Gn())}function Nc(e){return No(Wn(e))}function No(e){return new Date(Hn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function jc(){return new Uint32Array(se(4))[0]}var Ct={base62:{uuid:Do,uuidDecode:Po,uuidEncode:So},base32:{uuid:Ro,uuidDecode:Io,uuidEncode:ko},uuidv4:{uuid:Bo,uuidDecode:Oo,uuidEncode:$o}},He="base62",zn=!1;function Vc(e,t=!1){He=e,zn=t;}function Y(){return Ct[He].uuid(zn?Gn():vt())}function Wn(e){return Ct[He].uuidDecode(e)}function jo(e){return Ct[He].uuidEncode(e)}function Hc(e){try{return Wn(e).length===Ve}catch{}return !1}var At={};function _(e="id"){return At[e]==null&&(At[e]=0),`${e}-${At[e]++}`}var Vo=0;function Gc(){return `id-${Vo++}`}var Et=class extends M{constructor(){super(...arguments);this.id=Y();}close(){this.dispose();}},Ge=class extends Et{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:Y()});}};function Jc(){let e=new Ge,t=new Ge;return e.other=t,t.other=e,[e,t]}var qn=class{async encode(t){return t}async decode(t){return t}},le=class{async encode(t){return Qe(t)}async decode(t){return Xe(t)}},Jn=class{constructor(t){this.key=t;}async encode(t){let n=Qe(t);return await fn(n,this.key)}async decode(t){let n=await pn(t,this.key);return Xe(n)}};var Zn=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function ol(e={}){let{name:t=_("hub"),encoder:n=new le,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=R(t,i),s={},u,c=[],p,l={},f=()=>{clearTimeout(p);},d=async()=>{if(clearTimeout(p),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(T){a.warn("postMessage",T);break}}c.length>0&&r>0&&(p=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async T=>{a("onmessage",typeof T);let{name:v,args:U,id:h,result:x,error:L}=await n.decode(T.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let C=s[v](...U);I(C)&&(C=await C),a(`result ${C}`),h&&await g({id:h,result:C});}catch(C){let w=C instanceof Error?C:new Error(ht(C));a.warn("execution error",w.name),await g({id:h,error:{message:w.message,stack:w.stack,name:w.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[C,w]=l[h];if(C&&w)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,a.warn("reject",D.name),w(D);}else a("resolve",x),C(x);}else o||a.warn("Unhandled message",T);}),await d();},b=async(y,T,v={})=>{let{timeout:U=5e3}=v,h=Y();return await g({name:y,args:T,id:h}),Cn(new Promise((x,L)=>l[h]=[x,L]),U)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(s,y);},send(){return Zn(b,{},{options(y){return Zn(b,{...y})}})}}}var Ut=class extends M{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new le,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??_("pubsub"),this.log=R(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:p}=u;await this.emitSuper(c,...p);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function ll(e){return new Ut(e)}var Ho=1;var Kn=e=>e,Go=Kn;function pl(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Kn,deserialize:a=Go}=t,s=new Map;return r(async u=>{let c=a(u),[p,l,f,d]=c;if(p===1||p===2){let g,m;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";p===1&&f&&n(i(m?[4,m,f]:[3,g,f]));}else if(f){let g=s.get(f);g!=null&&(p===4?g.reject(l):g.resolve(l)),s.delete(f);}}),new Proxy({},{get(u,c){let p=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return p.asEvent=p,p;let l=(...f)=>new Promise((d,g)=>{let m=Ho++;s.set(m,{resolve:d,reject:g}),n(i([1,f,m,c]));});return l.asEvent=p,l}})}var Q=class extends M{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??_("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Q(n);return this.addChild(r),r}removeChild(n){dn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function Al(e={}){let{maxParallel:t=3,name:n=_("pool"),idConflictResolution:r="memoize"}=e,o=new M,i=he();i.add(T);let a=new Q({name:n});a.on("progressCancelled",T);let s=0,u=0,c=0,p=0,l={};async function f(){if(s>0){let[h,x]=vn();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:C,state:w}of Object.values(l))h+=L,x+=w==="finished"?L:Math.min(L,C);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(C=>C.state==="running"&&C.id!==L.id&&C.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,C=x.done;x.state="running",++c,o.emit("didStart",L);let w=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(D=>{C(D),o.emit("didResolve",L,D),w(D);}).catch(D=>{C(),o.emit("didReject",L,D),w();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function T(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function U(h,x={}){let L,C=new Promise(P=>L=P),w=x.id??Y();if(l[w]!=null){let P=x.idConflictResolution??r;if(P==="replace")y(w);else if(P==="memoize"||P==="prioritize"){let Bt=l[w];return P==="prioritize"&&(Bt.priority=++p),{id:w,promise:(async()=>{if(Bt.state==="finished")return l[w].result})(),dispose:()=>y(w),cancel:()=>y(w)}}else throw new Error(`Pool task with id=${w} already exists!`)}let D=new Q({name:w,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(D),l[w]={id:w,task:h,priority:++p,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(P){D.setTotalUnits(P),l[w].max=P,m();},setResolved(P){D.setCompletetedUnits(P),l[w].resolved=P,m();},incResolved(P=1){D.incCompletedUnits(P),l[w].resolved+=P,m();}},++s,b(),{id:w,promise:C,dispose:()=>y(w),cancel:()=>y(w)}}return {events:o,cancel:y,cancelAll:T,hasById:v,progress:a,enqueue:U,dispose:i,waitFinishAll:f}}var Yn=class extends M{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=_("queue"),logLevel:o}=n;this.name=r,this.log=R(`zeed:queue:${r}`,o??ee);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=_(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Pl(e,t={}){let {delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function p(){return i?(clearTimeout(i),i=void 0,!0):!1}function l(...f){let d=Date.now(),g=d-a,m=()=>{s=0,a=Date.now(),e.apply(this,f);};if(u=m,g>n||!i){o&&(g>n?m():++s);let b=g>n?n:n-g;p(),a=d,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},b);}else ++s;}return l.cancel=p,l.stop=()=>{p()&&u&&u();},l.immediate=async function(...d){p(),a=Date.now(),e.apply(this,d);},l.dispose=()=>l.stop(),l}function Rl(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let p=[...i];i=void 0,o=!0,await H(e(...p)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...p){i=[...p],a(),o===!1&&(r=setTimeout(s,n));}async function c(...p){a(),i=[...p],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function Il(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}var Qn=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"];function Bl(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return Qn[Math.abs(t)%Qn.length]}function Nl(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=N(n),i=z(t);return a=>{i(a.level)&&o(a.name)&&(a.timestamp=K(),r.push(a));}}var Ft={cache:"no-cache",redirect:"follow",headers:{}};function zo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function Xn(e,t={},n=fetch){try{G(t)&&(t=je({},...ae(t)));let r=zo(String(e));r&&(e=r.url,t=je({},t,Wo(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=R("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){R("zeed:network").error("fetchBasic",r);}}async function zl(e,t={},n=fetch){try{let r=await Xn(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){R("zeed:network").error("fetchJSON error:",r);}}async function Wl(e,t={},n=fetch){try{let r=await Xn(e,[Ft,{method:"GET"},t],n);if(r)return await r.text()}catch(r){R("zeed:network").error("fetchHTML error:",r);}}function ql(e,t="POST"){return {method:t,...Ft,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:_n(e)}}function Jl(e,t="POST"){return {method:t,...Ft,headers:{"Content-Type":"application/json; charset=utf-8"},body:k(e)}}function Wo(e,t){return {headers:{Authorization:`Basic ${fe(`${e}:${t}`)}`}}}function er(){if(typeof window<"u")return window}function qo(){if(typeof navigator<"u")return navigator}function Kl(){return er()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function Yl(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=qo(),n=er();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Jo(){return typeof window<"u"&&globalThis===window}function Ql(e){Jo()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var tr=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=ce(n);}getItem(t){return ce(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var nf=()=>{};function sf(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=hn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((f,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let b of m)f[r(b)]=r(g);return f},{}),u={_:[]};function c(f,d){u[f]==null||typeof u[f]=="boolean"?u[f]=d:Array.isArray(u[f])?u[f].push(d):u[f]=[u[f],d];}let p=[...t],l;for(;l=p.shift();){let f;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),f=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(f=f??p.shift()??"",a.includes(d)&&(f=Number(f??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(f):u[d]=[f]:c(d,f));}else u._.push(l);}return u}function uf(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function ff(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&Dt__default.default&&Dt__default.default.webcrypto&&(globalThis.crypto=Dt__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function pf(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Ko=`
`,Yo=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Qo=/\\n/g,Xo=/\n|\r|\r\n/;function nr(e,t={}){let n={};return String(e).split(Xo).forEach((r,o)=>{let i=r.match(Yo);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(Qo,Ko))):s=s.trim(),n[a]=s;}}),n}function ei(e,t="."){return path.resolve(process.cwd(),e??t)}function ti(e,t=""){return e==null&&(e=t),ei(String(e).trim(),t)}var St=ti;function yf(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function hf(e={}){let t=e?.path??St(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=ze__default.default.existsSync(t)?nr(ze__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=ze__default.default.existsSync(`${t}.local`)?nr(ze__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function Tf(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function Rt(e){try{await promises.stat(e);}catch{return !1}return !0}function We(e){return e.startsWith(".")||e.includes("/.")}async function Lf(...e){let t=path.join(...e);return await Rt(t)||await promises.mkdir(t,{recursive:!0}),t}async function Af(...e){let t=path.join(...e);return await Rt(t)&&await promises.rm(t,{recursive:!0}),t}async function vf(...e){let t=path.join(...e);if(await Rt(t))return await promises.readFile(t,"utf-8")}async function Cf(e,t){await promises.writeFile(e,t,"utf-8");}function qe(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,p=n.length;c<p;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],f=1;for(;n[c+1]==="*";)f++,c++;let d=n[c+1];i?f>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function or(e){try{return ze.statSync(e)}catch{}}function Rf(e){let{mtimeMs:t,size:n}=or(e)??{};return `${e}|${t}|${n}`}function ir(e,t="",n=!0){let r=[],o=ze.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&We(i))continue;let a=path.join(e,i),s=or(a);s&&s.isDirectory()?r=r.concat(ir(e,i)||[]):r.push(i);}return r}function kf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=ir(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=qe(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function ar(e){try{return await promises.stat(e)}catch{}}async function _f(e){let{mtimeMs:t,size:n}=await ar(e)??{};return `${e}|${t}|${n}`}async function ur(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&We(i))continue;let a=path.join(e,i),s=await ar(a);s&&s.isDirectory()?r=r.concat(await ur(e,i)||[]):r.push(i);}return r}async function Nf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=await ur(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=qe(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var fr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?k(n,null,2):k(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??In;}setItem(t,n){this.store[t]=ce(n);try{let r=this.objectToString(n),o=this.getPath(t);ze.mkdirSync(path.dirname(o),{recursive:!0}),ze.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(ze.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return ce(n);try{let r=this.getPath(t),o=ze.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);ze.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},ze.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=ze.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var pr={};function dr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),ze.mkdirSync(path.dirname(e),{recursive:!0});let a=ze.createWriteStream(e,{flags:"a"}),s=N(r),u=z(n);return c=>{if(!u(c.level)||!s(c.name))return;let p=o?`${new Date().toISOString()} `:"",l=c.name||"",f=pr[l||""];f==null&&(pr[l]=f);let d=[`[${l||"*"}]`,$e(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case O:g(`${p}I|*  `,...d);break;case B:g(`${p}W|** `,...d);break;case $:g(`${p}E|***`,...d);break;default:g(`${p}D|   `,...d);break}}}function vi(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Sn)??[]}function mr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Ci(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function kt(e=2,t=!0){let n=new Error("stack").stack||"",r=vi(n)?.[e];return r&&t&&(r=mr(r)),r||""}function yr(){return new Error("stack").stack||""}function hr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Ci(n)),n&&t&&(n=mr(n));}return n}function Ui(){try{return ue(process.env.ZEED_COLOR,Ei__default.default.isatty(process.stdout.fd))}catch{}return !1}var It,xr=[6,2,3,4,5,1];function Fi(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return xr[Math.abs(t)%xr.length]}var br={},Mt;function Je(...e){process.stdout.write(`${$e(e)}
`);}var be={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var Tr="\x1B[0m";function xe(e,t){return `${t===8?be.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${Tr}`}function wr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=Tr;return n&&(o=`${be.BOLD}${o}`,i=`${i}${be.BOLD}`),`${o}${r}${i}`})}var Di="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function Lr(e={}){It==null&&(It=Ui()),Mt==null&&(Mt=K());let{level:t=void 0,filter:n=void 0,colors:r=It,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=!0,time:c=!0}=e,p=N(n),l=z(t);return f=>{if(!l(f.level)||!p(f.name))return;let d=K(),g=f.name||"",m=br[g||""];m==null&&(m={color:Fi(g)},br[g]=m);let b=Lt(d-Mt),y,T=i?`[${g}]`:g;if(a>0&&(T=T.padStart(a," ")),s>0&&(T=T.padEnd(s," ")),r){let h=m.color;y=[`${xe(T,h)} | `],f.level===B?y.push(...wr(f.messages,be.ORANGE)):f.level===$?y.push(...wr(f.messages,be.RED)):y.push(...f.messages),c&&y.push(xe(`+${b}`,h));}else y=[T,...f.messages],c&&y.push(`+${b}`);if(f.messages?.[0]===Di&&console.log(yr()),u){let h="";typeof u=="boolean"?(h=hr(["at Function.","at null.log (","at log ("],!0),h||(h=kt(0,!0))):h=kt(typeof u=="number"?u:3,!0),h&&y.push(xe(`(${h})`,7));}let v="|",U=".";switch(f.level){case O:o&&(y[0]=`I${v}${U}   ${y[0]}`),Je(...y);break;case B:o&&(y[0]=(r?xe(`W${v}${U}${U}  `,8):`W${v}${U}${U}  `)+y[0]),Je(...y);break;case $:o&&(y[0]=(r?xe(`E${v}${U}${U}${U} `,1):`E${v}${U}${U}${U} `)+y[0]),Je(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),Je(...y);break}}}function Si(e,t){return Ye(n=>{let r=[Lr({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=ue(process.env.ZEED_TIME,!0),a=ue(process.env.ZEED_PRETTY,!1);o&&r.unshift(dr(St(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = an;
exports.CRYPTO_DEFAULT_ALG = lt;
exports.CRYPTO_DEFAULT_DERIVE_ALG = un;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Wr;
exports.CRYPTO_DEFAULT_HASH_ALG = cn;
exports.Channel = Et;
exports.CryptoEncoder = Jn;
exports.DAY_MS = bn;
exports.Day = A;
exports.DefaultLogger = R;
exports.Emitter = M;
exports.FileStorage = fr;
exports.JsonEncoder = le;
exports.LocalChannel = Ge;
exports.LogLevelAlias = $t;
exports.LogLevelAll = W;
exports.LogLevelDebug = J;
exports.LogLevelError = $;
exports.LogLevelFatal = Te;
exports.LogLevelInfo = O;
exports.LogLevelOff = ee;
exports.LogLevelWarn = B;
exports.Logger = Si;
exports.LoggerConsoleHandler = we;
exports.LoggerContext = Ot;
exports.LoggerFileHandler = dr;
exports.LoggerMemoryHandler = Nl;
exports.LoggerNodeHandler = Lr;
exports.MemStorage = tr;
exports.NoopEncoder = qn;
exports.Progress = Q;
exports.PubSub = Ut;
exports.SerialQueue = Yn;
exports.Uint8ArrayToDataUri = Ea;
exports.Uint8ArrayToHexDump = qt;
exports.Uint8ArrayToJson = Xe;
exports.Uint8ArrayToString = Ht;
exports.XRX = jn;
exports._decodeUtf8Polyfill = Pr;
exports._encodeUtf8Polyfill = Sr;
exports._useBase = no;
exports.arrayAvg = Ys;
exports.arrayBatches = Qs;
exports.arrayEmptyInPlace = Hs;
exports.arrayFilterInPlace = gt;
exports.arrayFlatten = ae;
exports.arrayIntersection = Qr;
exports.arrayIsEqual = eo;
exports.arrayMax = Js;
exports.arrayMin = Zs;
exports.arrayMinus = Kr;
exports.arrayRandomElement = qs;
exports.arrayRemoveElement = dn;
exports.arraySetElement = js;
exports.arrayShuffle = zs;
exports.arrayShuffleForce = Ws;
exports.arrayShuffleInPlace = gn;
exports.arraySorted = Xr;
exports.arraySortedNumbers = Gs;
exports.arraySum = Ks;
exports.arraySymmetricDifference = Ns;
exports.arrayToggleInPlace = Vs;
exports.arrayUnion = Yr;
exports.arrayUnique = dt;
exports.assert = Fr;
exports.assertCondition = Nt;
exports.avg = Ss;
exports.between = Ds;
exports.bitfield = bs;
exports.blobToArrayBuffer = zr;
exports.blobToDataUri = Ca;
exports.blobToUint8Array = ws;
exports.browserSelectColorByName = Bl;
exports.cloneJsonObject = su;
exports.cloneObject = ce;
exports.cmp = pt;
exports.colorString = xe;
exports.colorStringList = wr;
exports.composeOrderby = Ms;
exports.createArray = Xs;
exports.createBinaryStreamDecoder = xs;
exports.createBinaryStreamEncoder = hs;
exports.createLocalChannelPair = Jc;
exports.createPromise = vn;
exports.createPromiseProxy = Zn;
exports.csvParse = Uo;
exports.csvParseToObjects = uc;
exports.csvStringify = ac;
exports.dataUriToBlob = va;
exports.dataUriToMimeType = Aa;
exports.dataUriToUint8Array = La;
exports.dateStringToDays = Ja;
exports.day = qa;
exports.dayDay = ao;
exports.dayDiff = Ia;
exports.dayFromAny = Da;
exports.dayFromDate = _e;
exports.dayFromDateGMT = Pa;
exports.dayFromParts = wt;
exports.dayFromString = An;
exports.dayFromTimestamp = uo;
exports.dayFromToday = Ln;
exports.dayIterator = Ba;
exports.dayMonth = wn;
exports.dayMonthStart = Ra;
exports.dayOffset = Oe;
exports.dayRange = Ma;
exports.dayToDate = Tn;
exports.dayToDateGMT = Sa;
exports.dayToParts = Fa;
exports.dayToString = co;
exports.dayToTimestamp = xt;
exports.dayYear = bt;
exports.dayYearStart = ka;
exports.debounce = Rl;
exports.decimal = lo;
exports.decimalCentsPart = Qa;
exports.decimalFromCents = Ka;
exports.decimalToCents = Ya;
exports.decodeBase16 = ra;
exports.decodeBase32 = mn;
exports.decodeBase58 = ia;
exports.decodeBase62 = yn;
exports.decodeJson = ys;
exports.decrypt = pn;
exports.deepEqual = po;
exports.deepMerge = je;
exports.deepStripUndefinedInPlace = go;
exports.deriveKeyPbkdf2 = vs;
exports.detect = Yl;
exports.diffObjects = mo;
exports.digest = As;
exports.duration = kc;
exports.empty = iu;
exports.encodeBase16 = na;
exports.encodeBase32 = mt;
exports.encodeBase58 = oa;
exports.encodeBase62 = yt;
exports.encodeJson = ms;
exports.encodeQuery = _n;
exports.encrypt = fn;
exports.endSortWeight = On;
exports.ensureFolder = Lf;
exports.ensureKey = tu;
exports.ensureKeyAsync = nu;
exports.equalBinary = Wt;
exports.escapeHTML = Pn;
exports.escapeRegExp = Mn;
exports.estimateSizeForBase = sa;
exports.exists = Rt;
exports.fatal = Ur;
exports.fetchBasic = Xn;
exports.fetchJson = zl;
exports.fetchOptionsBasicAuth = Wo;
exports.fetchOptionsFormURLEncoded = ql;
exports.fetchOptionsJson = Jl;
exports.fetchText = Wl;
exports.files = kf;
exports.filesAsync = Nf;
exports.first = ru;
exports.fixBrokenUth8String = ba;
exports.forEachDay = za;
exports.forTimes = cu;
exports.formatMessages = so;
exports.formatMilliseconds = Lt;
exports.fromBase64 = ve;
exports.fromBase64String = Qi;
exports.fromCamelCase = ca;
exports.fromHex = zt;
exports.getEnvVariableRelaxed = yf;
exports.getFingerprint = Rf;
exports.getFingerprintAsync = _f;
exports.getGlobal = Kl;
exports.getGlobalContext = X;
exports.getGlobalEmitter = Dc;
exports.getGlobalLogger = Ye;
exports.getGlobalLoggerIfExists = _t;
exports.getNamespaceFilterString = vr;
exports.getNavigator = qo;
exports.getPerformanceTimestamp = Vn;
exports.getSecureRandom = qr;
exports.getSecureRandomIfPossible = S;
exports.getSourceLocation = kt;
exports.getSourceLocationByPrecedingPattern = hr;
exports.getStack = yr;
exports.getStackLlocationList = vi;
exports.getStat = or;
exports.getStatAsync = ar;
exports.getTimestamp = K;
exports.getWebCrypto = pf;
exports.getWindow = er;
exports.globToRegExp = qe;
exports.immediate = _a;
exports.isArray = G;
exports.isBoolean = Dn;
exports.isBrowser = Jo;
exports.isEmpty = fo;
exports.isEven = Bn;
exports.isHalf = ye;
exports.isHiddenPath = We;
exports.isInteger = du;
exports.isLocalHost = Il;
exports.isNotEmpty = xu;
exports.isNotNull = Sn;
exports.isNull = yu;
exports.isNullOrUndefined = mu;
exports.isNumber = Fn;
exports.isObject = j;
exports.isPrime = Rs;
exports.isPrimeRX = Ps;
exports.isPrimitive = Tt;
exports.isPromise = I;
exports.isRecord = Ne;
exports.isRecordPlain = pu;
exports.isSafeInteger = gu;
exports.isString = Un;
exports.isTimeout = ja;
exports.isTruthy = wu;
exports.isUint8Array = hu;
exports.isValue = bu;
exports.joinToUint8Array = Ki;
exports.jsonStringify = qi;
exports.jsonStringifySafe = k;
exports.jsonStringifySorted = Wi;
exports.jsonToUint8Array = Qe;
exports.last = ou;
exports.lazyListener = Sc;
exports.linkifyPlainText = tc;
exports.listDistinctUnion = Du;
exports.listGroupBy = Fu;
exports.listOfKey = Su;
exports.listQuery = Uu;
exports.loggerStackTraceDebug = Di;
exports.memoize = au;
exports.memoizeAsync = uu;
exports.moveSortWeight = Zu;
exports.noop = nf;
exports.objectIsEmpty = Mu;
exports.objectMap = ku;
exports.objectMergeDisposable = Iu;
exports.parseArgs = sf;
exports.parseBasicAuth = zo;
exports.parseDate = Rc;
exports.parseLogLevel = Ze;
exports.parseOrderby = Zr;
exports.parseQuery = nc;
exports.pbcopy = uf;
exports.promisify = H;
exports.qid = Gc;
exports.randomBoolean = Es;
exports.randomFloat = Fs;
exports.randomInt = Us;
exports.randomUint8Array = se;
exports.readText = vf;
exports.regExpEscape = oc;
exports.regExpString = Co;
exports.removeFolder = Af;
exports.renderMessages = $e;
exports.roundDown = Nu;
exports.roundHalfAwayFromZero = Hu;
exports.roundHalfDown = Gu;
exports.roundHalfEven = zu;
exports.roundHalfOdd = Vu;
exports.roundHalfTowardsZero = Wu;
exports.roundHalfUp = ju;
exports.roundUp = _u;
exports.seededRandom = ks;
exports.setUuidDefaultEncoding = Vc;
exports.setupEnv = hf;
exports.setupWebCrypto = ff;
exports.size = En;
exports.sleep = Oa;
exports.sortedItems = wo;
exports.sortedOrderby = Bs;
exports.startSortWeight = $n;
exports.stringToBoolean = pa;
exports.stringToFloat = ga;
exports.stringToInteger = da;
exports.stringToPath = ei;
exports.stringToUInt8Array = Vt;
exports.suid = _c;
exports.suidBytes = Gn;
exports.suidBytesDate = No;
exports.suidDate = Nc;
exports.sum = Jr;
exports.throttle = Pl;
exports.timeout = Na;
exports.toBase64 = fe;
exports.toBase64Url = Yi;
exports.toBool = xa;
exports.toCamelCase = hn;
exports.toCapitalize = ro;
exports.toCapitalizeWords = ua;
exports.toFloat = ma;
exports.toHex = Gt;
exports.toHumanReadableFilePath = Tf;
exports.toHumanReadableUrl = Lo;
exports.toInt = ya;
exports.toPath = St;
exports.toString = ha;
exports.toUint8Array = E;
exports.toValidFilename = In;
exports.today = Wa;
exports.tryTimeout = Cn;
exports.uname = _;
exports.unescapeHTML = Cu;
exports.useAsyncMutex = Lc;
exports.useBase = q;
exports.useDefer = mc;
exports.useDispose = he;
exports.useDisposer = gc;
exports.useEventListener = xc;
exports.useExitHandler = Ql;
exports.useInterval = hc;
exports.useLevelFilter = z;
exports.useMessageHub = ol;
exports.useMutex = Tc;
exports.useNamespaceFilter = N;
exports.usePool = Al;
exports.usePubSub = ll;
exports.useRPC = pl;
exports.useSorted = Qu;
exports.useTimeout = yc;
exports.uuid = Y;
exports.uuid32bit = jc;
exports.uuidB32 = Ro;
exports.uuidB62 = Do;
exports.uuidBytes = vt;
exports.uuidDecode = Wn;
exports.uuidDecodeB32 = Io;
exports.uuidDecodeB62 = Po;
exports.uuidDecodeV4 = Oo;
exports.uuidEncode = jo;
exports.uuidEncodeB32 = ko;
exports.uuidEncodeB62 = So;
exports.uuidEncodeV4 = $o;
exports.uuidIsValid = Hc;
exports.uuidv4 = Bo;
exports.valueToBoolean = ue;
exports.valueToFloat = io;
exports.valueToInteger = oo;
exports.valueToPath = ti;
exports.valueToString = ht;
exports.waitOn = Va;
exports.walkSync = ir;
exports.walkSyncAsync = ur;
exports.writeText = Cf;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map